import { SelectQueryBuilder } from "typeorm";
import CommonHelper from "../helpers/common";
import { OrmHelper } from "../helpers/orm";
import { FactoryToSupplier } from "entity";

export class FactoryToSupplierModel {
    static async list(filter = {}): Promise<SelectQueryBuilder<any>> {
        const repo = OrmHelper.DB.getRepository(FactoryToSupplier);
        let whereAttr: string[] = [];
        let whereVal: any = {};
        if (filter && Object.keys(filter).length > 0) {
            whereAttr = [...whereAttr, ...CommonHelper.handleQueryFilter(filter, "factory_to_supplier").whereAttr];
            whereVal = { ...whereVal, ...CommonHelper.handleQueryFilter(filter, "factory_to_supplier").whereVal };
        }

        var query = repo.createQueryBuilder("factory_to_supplier")
            .leftJoinAndSelect("factory_to_supplier.factory", "factory")
            .leftJoinAndSelect("factory_to_supplier.supplier", "supplier")
        if (whereAttr.length != 0) {
            query = query.where(whereAttr.join(" and "), whereVal);
        }

        return query;
    }
}